<?php
/**
*	Class de email
*	Sera Instanciada desde el TGod
*
*	Santiago Rodriguez  
*	santi@camboya.ws
*	2009-07-24
*/
class TEmail
{
	private $subject;
	private $fromName;
	private $fromEmail;
	private $to = array();		//par de nombre, email
	private $body = "";
	private $templateBody = null;
	private $keyValues = array();	//para el body...
	private $contentType;
	private $isWindows = false;
	
	public function TEmail($contentType)
	{
		$this->contentType = $contentType;
		$this->subject = MAIL_SUBJECT;
		$this->fromName = MAIL_FROM_NAME;
		$this->fromEmail = MAIL_FROM_EMAIL;
	}
	
	public function setSubject($subject)
	{
		$this->subject = $subject;
	}
	
	public function setIsWindows($isWin)
	{
		$this->isWindows = $isWin;
	}
	
	public function setFromName($fromName)
	{
		$this->fromName = $fromName;
	}
	
	public function setFromEmail($fromEmail)
	{
		$this->fromEmail = $fromEmail;
	}
	
	public function setBody($body)
	{
		$this->body = $body;
	}
	
	public function setTemplateBody($templateBody)
	{
		$this->templateBody = $templateBody;
	}
	
	public function addTo($toName, $toEmail)
	{
		$this->to[] = array($toName, $toEmail);
	}
	
	public function addKeyValues($key, $value)
	{
		$this->keyValues[$key] = $value;
	}
	
	public function send()
	{
		$header = "From: " . (($this->isWindows)?"":("\"" . $this->fromName . "\"")) . " <" . $this->fromEmail . ">\n";
		$header .= "X-Mailer:PHP/" . phpversion() . "\n";
		$header .= "MIME-Version: 1.0\n";
		$header .= "Content-type: " . $this->contentType;
		
		$this->body = ($this->templateBody == null) ? $this->body : file_get_contents($this->templateBody);
		foreach($this->keyValues as $key => $value)
			$this->body = str_replace($key, $value, $this->body);

		foreach($this->to as $arr)
		{
			$subject = str_replace("##NAME##", $arr[0], $this->subject);
			$body = str_replace("##NAME##", $arr[0], $this->body);
			$body = str_replace("##EMAIL##", $arr[1], $body);
			
			mail($arr[1], "".$subject."", $body, $header);
		}
	}
}
?>