<?php
/**
*	Clase TGod que instancia todas las clases necesarias para manejo de sitios web standard
*	Para el funcionamiento se tiene en cuenta PHP5, mysql5, extension mysqli
*
*	Santiago Rodriguez  
*	santi@camboya.ws
*	2009-07-21
*/
require('config.php');
require('validator.php');
require('db.php');
require('xml.php');
require('email.php');
require('sn.php');
require('session.php');	

abstract class TGod
{
	public $val;			//Manejo de Validaciones
	public $sql;			//Manejo de Conexiones a Base de Datos
	public $xml;			//Manejo de XML
	public $mail;			//Manejo de Mailing
	public $sn;				//Manejo de Social Networks
	
	
	protected $methodArr;	

	//Constructor 
	public function TGod($methodArray, $nodeName)
	{
	
		$this->val = (($methodArray != VAL_NONE) ? (new TValidator($methodArray)) : null);
		$this->sql = new TSQL();
		$this->xml = new TXMLResponse($nodeName);
		$this->methodArr = (($methodArray != VAL_NONE) ? (($methodArray == VAL_POST) ? $_POST : $_GET) : null);
		$this->sn = new TSocialNetwork();
		
	}
	
	public function printXmlError()
	{
		$err = $this->val->getFirstError();
		$this->xml->getInvalidRequestData($err[0], $err[1]);
	}

	//Devuelve un timestamp teniendo como parte flotante los milisegundos
	protected function getTs()
	{
		$arr = explode(" ", microtime());
		return sprintf("%f", (float)$arr[0] + (float)$arr[1]);
	}
	
	//Inicializa la variable que maneja el email
	public function startEmail($contentType)
	{
		$this->mail = new TEmail($contentType);
	}
	
	//Devuelve la edad actual en base a una fecha. Recibe DD-MM-YYYY
	protected function getAge($bdate)
	{
		if($bdate == null || strlen($bdate) == 0)
			return 0;
		$today = time();
		$arrBirth = explode("-", $bdate);
		$diff = date("Y", $today) - (int)$arrBirth[2];
		if((date("z", $today) - date("z", mktime(0,0,0, $arrBirth[1], $arrBirth[2], $arrBirth[0]))) < 0)
			$diff--;
			
		return $diff;
	}
	
	public function test()
	{
		try{
			$this->sql->setQuery("SHOW TABLES;");
			$limit = $this->sql->executeQuery();
			
			$this->xml->printHeaders();
			echo $this->xml->getOKBasic() . " count=\"" . $limit . "\">";
				while($row = $this->sql->getRow())
				{	
					echo "<item row0=\"" . $row[0] . "\" />";
				}
			$this->xml->getClose();
			exit();
		}
		catch (Exception $e)  {
			$this->xml->getInternalError($e->getMessage());

		}
	}
}
?>
