<?php
/**
*	Clase madre para comunicacion XML con Flash
* 	Sera instanciada desde el TGod
*
*	Santiago Rodriguez  
*	santi@camboya.ws
*	2009-07-21
*/

class TXMLResponse 
{
	private $nodename;
	
	public function TXMLResponse($nodeName)
	{
		if($nodeName != null && $nodeName != "")
			$this->nodename = $nodeName;
		else $this->nodename = "response";
	}
	
	public function printHeaders()
	{
		header("Cache-Control: no-cache, must-revalidate");
		header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");
		header ("Content-type: text/xml");
		echo "<?xml version=\"1.0\" encoding=\"" . XML_ENC . "\" ?>";
	}
	
	public function getInvalidRequestData($field, $validationMsg)
	{
		$this->printHeaders();
		echo "<" . $this->nodename . " status=\"-2\" statusdescription=\"InvalidRequestData\" field=\"" . $field . "\" validationmessage=\"" . $validationMsg . "\" />";
		exit();
	}
	
	public function getInternalError($message)
	{
		$this->printHeaders();
		echo "<" . $this->nodename . " status=\"-1\" statusdescription=\"InternalError\" message=\"" . $message . "\"  />";
		exit();
	}
	
	public function getOKBasic()
	{
		return "<" . $this->nodename . " status=\"0\" statusdescription=\"OK\" ";
	}
	
	public function getClose()
	{
		echo "</" . $this->nodename . ">";
	}
	
	public function getOK()
	{
		$this->printHeaders();
		echo $this->getOKBasic() . " />";
		exit();
	}
	
	public function getNotFound()
	{
		$this->printHeaders();
		echo "<" . $this->nodename . " status=\"1\" statusdescription=\"NotFound\" />";
		exit();
	}
	
	public function getAlreadyDone()
	{
		$this->printHeaders();
		echo "<" . $this->nodename . " status=\"2\" statusdescription=\"AlreadyDone\" />";
		exit();
	}
}
?>